/*
Copyright (C) 2011 by Blazing Games Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
package
{
	import com.blazinggames.cgl.atlas.AnimationInfo;
	import com.blazinggames.cgl.atlas.AtlasMovie;
	import com.blazinggames.cgl.atlas.AtlasSprite;
	import com.blazinggames.cgl.atlas.ClipInfo;
	import com.blazinggames.cgl.atlas.ImageAtlas;
	import com.blazinggames.cgl.atlas.PageInfo;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	import flash.net.URLRequest;

	[SWF(width="64", height="64", frameRate="60", backgroundColor="#000050")]
	
	/**
	 * Runs the tests for the Blazing Games Image Atlas Animation Library.
	 * 
	 * @author Billy D. Spelchan
	 */
	public class Atlas extends Sprite
	{
// ***** CONSTANTS *****
		
		private var atlasXML:XML = <IMAGEATLAS>
<PAGE name='test' url='monsters3D.gif'
				w='512' h='512' color='0xFFFF88FF' >This is the testing page</PAGE>
<CLIP id='rat' page='test' x='384' y='0' w='64' h='64' 
				originX='0' originY='0' originType='top left' />
<CLIP id='rat[5]' page='test' x='256' y='0' w='64' h='64' 
				originX='0' originY='0' originType='top left' />
<CLIP id='rat[6]' page='test' x='320' y='0' w='64' h='64' 
				originX='0' originY='0' originType='top left' />
<CLIP id='rat[7]' page='test' x='384' y='0' w='64' h='64' 
				originX='0' originY='0' originType='top left' />
<CLIP id='rat[8]' page='test' x='448' y='0' w='64' h='64' 
				originX='0' originY='0' originType='top left' />
<ANIMATION name="attacking">
			<FRAME number='0' clip='rat[5]'  duration='125' />
			<FRAME number='1' clip='rat[6]'  duration='125' />
			<FRAME number='2' clip='rat[7]'  duration='125' />
			<FRAME number='3' clip='rat[8]'  duration='125' />
</ANIMATION>
<IMAGESTRIP baseName='standing' page='test' x='0' y='0' w='64' h='64' 
			frames='4' frameRate='125' />
</IMAGEATLAS>

// ***** VARIABLES *****
			
		private var _atlas:ImageAtlas;
		private var _movie:AtlasMovie;
		
// ***** CONSTRUCTOR *****
		
		public function Atlas()
		{
			_atlas = new ImageAtlas();
			_atlas.setFromXML(atlasXML, false);
			_movie = new AtlasMovie(_atlas, "standing", AtlasMovie.PLAYBACK_YOYO, false);
			_movie.addEventListener(MouseEvent.CLICK, onClick);
			addChild(_movie);
			trace(_atlas.toXMLString());
		}

// ***** METHODS - Event Handlers *****
		
		protected function onClick(event:MouseEvent):void
		{
			_movie.addEventListener(AtlasMovie.ANIMATION_FINISHED_EVENT, onAnimDone);
			_movie.setSequence("attacking", AtlasMovie.PLAYBACK_YOYO, false, 1);
		}
		protected function onAnimDone(event:Event):void
		{
			_movie.removeEventListener(AtlasMovie.ANIMATION_FINISHED_EVENT, onAnimDone);
			_movie.setSequence("standing", AtlasMovie.PLAYBACK_YOYO, false);
		}
		
		
	}
}